.text

#include "config.h"
#ifdef CONFIG_AG101P_16MB
#include "ag101_16mb.h"
#else
#include "ag101.h"
#endif
.globl remap
remap:
	move	$r9, $lp
	/* relocation, copy ROM code to SDRAM(current is at 0x10000000) */
#ifdef CONFIG_AG101P_16MB
	li	$r4, 0x800000
#else
	li	$r4, 0x10000000
#endif
	li	$r5, 0x0
	sethi	$r6, hi20(_edata)
	ori	$r6, $r6, lo12(_edata)
1:
	lwi     $r7, [$r5]
	swi     $r7, [$r4]
	addi    $r5, $r5, #4
	addi    $r4, $r4, #4
	blt     $r5, $r6, 1b

	/* Remapping */
	li  	$r0, SDRAMC_BASE /* SDRAMC Register */
	li	$r1, 0x00001100 /* Bank Enable, BASE = 0x100 for haddr[31:20] of the AHB address bus. */
	swi	$r1, [$r0+0x10] /* External Bank Configuration Registers */
	
	li	$r1, 0x0
	swi	$r1, [$r0+0x14] /* External Bank Configuration Registers */
	swi	$r1, [$r0+0x18] /* External Bank Configuration Registers */
	swi	$r1, [$r0+0x1c] /* External Bank Configuration Registers */
	li	$r1, 0x00001000
	swi	$r1, [$r0+0x10] /* Bank Disable, BASE = 0x100 for haddr[31:20] of the AHB address bus. */

	li	$r0, (AHBC_BASE+INTC_OFFSET)  
	lwi	$r1, [$r0]     
	ori	$r1, $r1, 0x1
	swi	$r1, [$r0]     /*When writing a 1 to this bit, the base/size configuration 
	                     of AHB slaves 4 (ROM) and 6 (SDRAM) will be interchanged. */

	li	$r0, SMC_BASE /* SMC Register */
#if defined(AG101)
	li	$r1, 0x10400062
	swi	$r1, [$r0+0x8]
	li	$r1, 0x000ff3ff
	swi     $r1, [$r0+0xc]
#else
#ifdef CONFIG_AG101P_16MB
	li	$r1, 0x10000052
#else
	li	$r1, 0x10400062 /*64 MB, Memory data width is 32 */
#endif
	swi	$r1, [$r0]
#endif

	move	$lp, $r9
2:
    	ret
